package com.bwie.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.nacos.common.utils.UuidUtils;
import com.bwie.common.constants.JwtConstants;
import com.bwie.common.constants.TokenConstants;
import com.bwie.common.domain.User;
import com.bwie.common.domain.request.JwtRequest;
import com.bwie.common.domain.request.UserRequest;
import com.bwie.common.result.Result;
import com.bwie.common.utils.JwtUtils;
import com.bwie.user.RemoteUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.sql.Time;
import java.util.HashMap;
import java.util.concurrent.TimeUnit;

/**
 * @author gxb
 * @description TODO
 * @date 2023-12-19 15:31
 */
@Service
public class AuthServicelmpl implements AuthService{
    @Autowired
    private RemoteUserService remoteUserService;
    @Autowired
    private HttpServletRequest request;
    @Autowired
    private StringRedisTemplate redisTemplate;

    @Override
    public Result login(UserRequest userRequest) {
        User user = remoteUserService.findName(userRequest.getUsername()).getData();
        if (null==user){
            return Result.error("用户名不存在！！！！！！！");
        }
        if (!user.getPassword().equals(userRequest.getPassword())){
            return Result.error("密码错误！！！！！！！");
        }
        JwtRequest token = this.getToken(user);
        return Result.success(token,"登录成功");
    }

    /**
     * 获取当前登录人
     * @return
     */
    @Override
    public Result info() {
        String token = request.getHeader(TokenConstants.TOKEN);
        String userKey = JwtUtils.getUserKey(token);
        String s = redisTemplate.opsForValue().get(TokenConstants.LOGIN_TOKEN_KEY + userKey);
        User user = JSON.parseObject(s, User.class);
        return Result.success(user,"当前登录人");
    }

    /**
     * 生成token
     */
    private JwtRequest getToken(User user){
        HashMap<String, Object> map = new HashMap<>();
        String userKey = UuidUtils.generateUuid().replaceAll("-", "");
        map.put(JwtConstants.USER_KEY,userKey);
        String token = JwtUtils.createToken(map);
       redisTemplate.opsForValue().set(TokenConstants.LOGIN_TOKEN_KEY+userKey,
               JSON.toJSONString(user),15,TimeUnit.MINUTES);
        return new JwtRequest(token);
    }
}
