package com.bwie.user.controller;

import com.bwie.common.domain.request.PacketRequest;
import com.bwie.common.domain.request.RedPacketRequest;
import com.bwie.common.domain.request.SendPacket;
import com.bwie.common.result.Result;
import com.bwie.user.service.PacketService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author gxb
 * @description TODO
 * @date 2023-12-29 9:29
 */
@RestController
public class PacketController {
    @Autowired
    private PacketService packetService;

    /**
     * 红包列表
     * @param packetRequest
     * @return
     */
    @PostMapping("/packetList")
    public Result packerList(@RequestBody PacketRequest packetRequest){
    return packetService.packerList(packetRequest);
    }
    /**
     *查询好友集合
     */
    @GetMapping("/findFriends")
    public Result findFriends(){
        return  packetService.findFriends();
    }
    /**
     * 添加红包
     */
    @PostMapping("/addPacket")
    public Result addPacket(@RequestBody SendPacket sendPacket) {

        return packetService.addPacket(sendPacket);
    }

    /**
     * 抢红包
     * @param redPacketRequest
     * @return
     */
    @PostMapping("/redPacket")
    public Result redPacket(@RequestBody RedPacketRequest redPacketRequest){
return packetService.redPacket(redPacketRequest);
    }
}
