package com.bwie.user.mapper;

import com.bwie.common.domain.Give;
import com.bwie.common.domain.Packet;
import com.bwie.common.domain.User;
import com.bwie.common.domain.request.PacketRequest;
import com.bwie.common.domain.request.RedPacketRequest;
import com.bwie.common.domain.request.SendPacket;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author gxb
 * @description TODO
 * @date 2023-12-29 9:29
 */
@Component
@Mapper
public interface PacketMapper {


    // 根据请求获取包列表
    List<Packet> packList(PacketRequest packetRequest);

    // 根据用户ID查询好友列表
    List<Integer> findFriends(Integer userId);

    // 根据用户ID查询用户名
    List<User> finduserName(@Param("findFriends") List<Integer> findFriends);

    // 发送包
    Integer InterPacket(SendPacket sendPacket);

    // 给指定用户发送包
    void InterGive(@Param("packetId") Integer packetId, @Param("userIds") List<Integer> userIds);

    // 更新用户余额
    void updateUserMoney(@Param("userId") Integer userId, @Param("packetPrice") Double packetPrice);

    // 查询包
    List<Packet> selectPacket();


    // 更新用户余额
    void updateaddUserMoney(@Param("userId") Integer userId, @Param("i") double i);

    // 查询结束金额
    User selectEndMoney(Integer userId);

    // 根据包ID查询包
    Packet selectPacketById(@Param("packetId") Integer packetId);

    // 根据用户ID和包ID查询真实信息
    Give findTrue(@Param("userId") Integer userId, @Param("packetId") Integer packetId);

    // 根据包ID查询包数量
    Packet findPackCount(Integer packetId);

    // 更新红包请求
    void UpdateRem( RedPacketRequest redPacketRequest);


    // 更新发送状态
    void UpdateGiveState(@Param("packetId") Integer packetId, @Param("userId") Integer userId);

    // 更新红包状态
    void UpdatePacketSang(@Param("packetId") Integer packetId);

    // 更新余额
    void UpdateYue(@Param("v") double v, @Param("userId") Integer userId);

    // 更新包状态
    void UpdatePacketState(Integer packetId);

    // 更新红包请求
    void UpdateRPacketRequest(Integer packetId);

    // 根据包ID查询包数量
    Packet findPacketCounts(Integer packetId);

}
