package com.bwie.user.controller;

import com.bwie.common.domain.User;
import com.bwie.common.domain.request.AddUser;
import com.bwie.common.domain.request.Conditit;
import com.bwie.common.domain.request.Inqri;
import com.bwie.common.result.Result;
import com.bwie.user.service.impl.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author gxb
 * @description TODO
 * @date 2023-12-19 15:32
 */
@RestController
public class UserController {
    @Autowired
    private UserService userService;
    @PostMapping("/findName/{username}")
    public Result<User> findName(@PathVariable("username") String username){
        return userService.findName(username);
    }

    /**
     * 发送验证码
     * @param tel
     * @return
     */
    @PostMapping("/sendCode/{tel}")
    public Result sendCoode(@PathVariable("tel") String tel){
        return userService.sendCode(tel);
    }

    /**
     * 注册
     * @param addUser
     * @return
     */
    @PostMapping("/Sign")
    public Result Sign(@RequestBody AddUser addUser){
        return userService.Sign(addUser);
    }
    /**
     * 用户登录展示好友列表
     */
    @PostMapping("/FriedList")
    public Result FriedList(@RequestBody Conditit conditit){
        return userService.FriedList(conditit);
    }

    /**
     * 删除好友
     * @param userId
     * @return
     */
    @PostMapping("/deleUser/{userId}")
    public Result deleUser(@PathVariable Integer userId){
        return  userService.deleUser(userId);
    }
    /**
     * 添加好友列表
     */
    @PostMapping("/Addfriends")
    public Result  Addfriends(@RequestBody Inqri inqri){
        return userService.Addfriends(inqri);
    }

    /**
     * 申请添加好友
     * @param userId
     * @return
     */
    @PostMapping("/FriedRequest/{userId}")
    public Result  FriedRequest(@PathVariable("userId") Integer userId){
        return  userService.FriedRequest(userId);
    }

    /**
     * 好友申请表
     * @return
     */
    @GetMapping("/FieList")
    public Result FieList(){
        return  userService.FieList();
    }
    /**
     * 级联 查所有
     */
    @GetMapping("/AllProcut")
    public Result  AllProcut(){
        return  userService.AllProcut();
    }
    /**
     * 查寻子类
     */
    @GetMapping("/subclass")
    public Result subclass(){
        return  userService.subclass();
    }
/**
 * 修改好友申请状态
 */
@PostMapping("/updateFriedRequest/{feiId}/{state}")
    public Result  updateFriedRequest(@PathVariable("feiId") Integer feiId,@PathVariable("state") Integer state){
    return   userService.updateFriedRequest(feiId,state);
    }
/**
 * 批量删除好友申请列表
 */
@PostMapping("/deleteFriedRequest")
    public Result   deleteFriedRequest(@RequestBody Integer[] ids){
    return   userService.deleteFriedRequest(ids);
    }
}
